<?php
/*  Copyright 2002-2003 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.

    This file adds the 'Q:' and 'A:' markup to PmWiki.  A line beginning
    with 'Q:' is rendered in boldface, and a line beginning with 'A:'
    is converted to a first-level indent.  

    This file is automatically included by stdconfig.php unless
    disabled in local.php.

    John Rankin modified it to use style sheets and add box (B: ... : ...) 
    and callout (C: ...) markups.
*/

$EnableQAMarkup = 0;
$DoubleBrackets['/^Q:(.*)$/'] = '<p class=\'q\'><b>$1</b></p>';
$DoubleBrackets['/^A:(.*)$/'] = '<p class=\'a\'>$1</p>';
$DoubleBrackets['/^B:([^:]*):(.*?)$/e'] = 
   '"<div class=\'box\'><h4" . boxheading(stripslashes("$1")) . 
    "</h4><p>" . stripslashes("$2") . "</p></div>";';
$DoubleBrackets['/^C:(.*)$/'] = '<div class=\'callout\'><p>$1</p></div>';

function boxheading($text) {
    if (preg_match("/^\\s+(.*)\\s+\$/",$text,$match)) 
          { return " align='center'>$match[1]"; }
    elseif (preg_match("/^\\s+(.*)/",$text,$match)) 
          { return " align='right'>$match[1]"; }
    return ">$text";
}

?>
