<?php

##  this supports footnotes and page tables of contents  ##
## it was also a convenient place to add acronym support ##
## Copyright 2003, 2004 John Rankin john.rankin@affinity.co.nz

$AutoContents = 0;
$DefaultTocTitle = 'Contents';
$TocHeaderFmt = '<b>$TocTitle</b>';
$IdPattern = "[A-Za-z][-.:_A-Za-z0-9]*";
$TitleTextPattern = "((?:.*?\\[.*?\\])*.*?)";
SDV($VisibleAnchor,'&sect');
$AutoTocPattern   = "toc(?:auto)";
$ManualTocPattern = "toc(?:manual)";
if ($AutoTocAsDefault) {
    $AutoTocPattern .= "?";
} else {
    $ManualTocPattern .= "?";
}
$RefOrTitle = ($VisibleAnchorLinks) ? 'href' : 'title';
if ($action=="print" || $action=="publish") {
   $DoubleBrackets["/^\\[\\[toc\\s*$TitleTextPattern\\]\\]/"] = '';
   $DoubleBrackets["/^(!+|Q?:)##?/"] = "$1";
   $InlineReplacements["/\\[(.*?)\\|(.*?)\\]/"] = "$1 ($2)";
   $LinkPatterns[780]["\\[\\[##($IdPattern)\\]\\]"] =
         "<a name='$1' id='$1'></a>";
} else {
   $DoubleBrackets["/^\\[\\[$AutoTocPattern(?:\\s+anchors=?(v)isible)?(?:\\s+$TitleTextPattern)?\\]\\]/e"]= 
        'NestedContents($text,"$1",stripslashes("$2"));';
   $DoubleBrackets["/^(!+|Q:)((\\[\\[#+$IdPattern\\]\\])|##?)?/e"] = 
        '"$1" . NestedAnchor("$1","$2");';
   $DoubleBrackets["/^(!+|Q?:)#(#?)/e"] = '"$1" . TocAnchor("$2");';
   $DoubleBrackets["/^\\[\\[$ManualTocPattern(?:\\s*(format)=?([lr])?([:*#])?)?(?:\\s+$TitleTextPattern)?\\]\\]/e"] = 
        'TableOfContents($text,"$1","$2","$3",stripslashes("$4"));';
   $DoubleBrackets["/^\\[\\[toc(?:([lr])?([:*#]))?(?:\\s+$TitleTextPattern)?\\]\\]/e"] = 
        'TableOfContents($text,"$2","$1","$2",stripslashes("$3"));';
   $InlineReplacements["/\\[(.*?)\\|(.*?)\\]/"] =
        "<acronym title='$2'>$1</acronym >";
   $LinkPatterns[780]["\\[\\[##($IdPattern)\\]\\]"] = 
 "<span class='anchor'><a name='$1' id='$1' $RefOrTitle='#$1'>$VisibleAnchor</a></span>";
}
$DoubleBrackets["/\\[\\[#($IdPattern)\\s*#\\]\\]/e"] = 
	'"[[#$1 " . CrossReference($text,"$1") . "]]";';
$DoubleBrackets["/\\[\\^#($IdPattern)\\^\\]/e"] = 'Shortcut($text,"$1");';
$DoubleBrackets["/\\[\\^(.*?)\\^\\]/e"] = 'Footnote("$1");';
$InlineReplacements["/`\./"]="";


function Footnote($foottext) {
  static $fncount, $fntext;
  if ($foottext == "#") {
     $fncount = 0;
     $r = "<div class='footnote'>&nbsp;</div>$fntext<p />";
     $fntext = '';
  } else {
     $fncount++;
     $r = "<sup><a href='#fn$fncount'>$fncount</a></sup>";
     $foottext = stripslashes($foottext);
     $fntext .= "<p class='footnote'><a name='fn$fncount' id='fn$fncount'><sup>$fncount</sup></a> $foottext</p>";
  }
  return $r;
}

function CrossReference($text,$anchor) {
    global $GroupNamePattern,$FreeLinkPattern,$WikiWordPattern,$IdPattern;
    $xref = FmtTextReplacements(Shortcut($text,$anchor));
    $xref = 
       preg_replace("/$GroupNamePattern\\/($WikiWordPattern|$FreeLinkPattern)/",
                    "$1",$xref);
    $xref = preg_replace("/`\\..*?$/","...",$xref);
    $xref = preg_replace("/\\[\\[$FreeLinkPattern\\]\\]/","$3$5",$xref);
    $xref = preg_replace("/\\[\\[#+$IdPattern\\]\\]/","",$xref);
    $xref = preg_replace("/\\[\\[(\\S+)\\]\\]/","$1",$xref);
    $xref = preg_replace("/\\[\\[{{.*?}}.*?\\s+(.*?)\\]\\]/", "$1", $xref);
    $xref = preg_replace("/\\[\\[.*?\\s+(.*?)\\]\\]/", "$1", $xref);
    $xref = preg_replace("/$FreeLinkPattern/","$3$5",$xref);
    return preg_replace("/($WikiWordPattern)/e","PreventWiki('$1')",$xref);
}

function PreventWiki($wordpattern) {
  global $SpaceWikiWords, $AsSpacedFunction;
  return ($SpaceWikiWords) ? $AsSpacedFunction($wordpattern) : $wordpattern;
}

function Shortcut($text,$anchor) {
  $text .= "\n";
  if (preg_match("/\\[\\[#+$anchor\\]\\]\\n?(.*?)\\n/",$text,$match)) {
    return preg_replace("/^[#*!:]+\s*/","",$match[1]);
  } else {
    return "'''$anchor''' not found.";
  }
}

function TableOfContents($text,$div,$align,$style,$title) {
  global $IdPattern,$AutoContents,$DefaultTocTitle,$TocHeaderFmt;
  global $TitleTextPattern,$AutoTocPattern;
  $r = '';
  if (!$align) $align = 'r';
  if (!$title) $title = $DefaultTocTitle;
  $toc = str_replace('$TocTitle',$title,$TocHeaderFmt);
  if ($style==':') {
      $l = 'dd';
      $s = 'dl';
      $toc = "<$s><dt>$toc</dt>";
  } else {
      $l = 'li';
      if ($style=='*') $s = 'ul';
      else $s = 'ol';
      if ($div) $toc = "<p>$toc</p>";
      $toc .= "<$s>";
  }
  $toc .= "\$List</$s>";
  if ($div) $toc = "<div class='toc$align'>$toc</div>";
  if ($AutoContents>=1) {
     $text = preg_replace("/\\[\\[$AutoTocPattern(\\s+$TitleTextPattern)?\\]\\]/",
                          '[[tocauto]]',$text);
     $text = str_replace(substr($text,0,strpos($text,'[[tocauto]]')),'',$text);
     $q = '#*';
  } else $q = '#+';
  preg_match_all("/\n(!+|[QT]?:)((\\[\\[#+$IdPattern\\]\\])|($q([^\n])*))/",$text, $match);
  $i = 0;
  foreach ($match[2] as $m) {
      $m = preg_replace("/^(\\[\\[)?##/","$1#",$m);
      if (strpos($m,'[#')==1) $r .= "<$l>".str_replace(']]','#]]',$m)."</$l>\n";
      else {
          if (($match[1][$i]!=':') || ($m[0]=='#'))$counter++;
          if ($m[0]=='#') {
             if ($match[1][$i]==':') $m = substr($m,0,strpos($m,':'));
  $r.="<$l>[[#toc$counter ".CrossReference("[[#]]".substr($m,1),"")."]]</$l>\n";
          }
      }
      $i++;
  }
  if ($r!='') $r = str_replace('$List',$r,$toc);
  return $r;
}

function TocAnchor($visible) {
  static $toccounter;
  return "[[$visible#toc" . ++$toccounter . "]]";
}

function NestedAnchor($h,$mark) {
  static $l1,$l2;
  global $AutoContents;
  if ($AutoContents==0) return $mark;
  if ($mark=='') $visibility = ($AutoContents==1) ? '#' : '##';
  else $visibility = $mark;
  if ($h=='Q:') return $visibility;
  $r = '';
  $len = strlen($h);
  if ($l1==0) { $l1 = $len; }
  else if ($len!=$l1 && $l2==0) { $l2 = $len; }
  if ($l1==$len || $l2==$len) $r = $visibility;
  return $r;
}

function NestedContents($text,$visible,$title) {
    global $AutoContents,$DefaultTocTitle,$TocHeaderFmt,$IdPattern;
    global $TitleTextPattern,$AutoTocPattern;
    $AutoContents = ($visible=='') ? 1 : 2;
    $l1 = 0; $l2 = 0; $l3 = 0;
    $q = 0;
    $r = '';
    if (!$title) $title = $DefaultTocTitle;
    $toc = str_replace('$TocTitle',$title,$TocHeaderFmt);
    $l = 'li'; $s = 'ol';
    $toc = "$toc<$s>\$List</$s>";
    $text = preg_replace("/\\[\\[$AutoTocPattern(\\s+$TitleTextPattern)?\\]\\]/",
                         '[[tocauto]]',$text);
    $text = str_replace(substr($text,0,strpos($text,'[[tocauto]]')),'',$text);
    preg_match_all("/\n(!+|Q?:)((\\[\\[#+$IdPattern\\]\\])|(#*[^\n]*))/",$text, $match);
    for ($i=0;$i<count($match[0]);$i++) {
         if ($match[1][$i]==':') {
            if ($match[2][$i][0]=='#')  $counter++; 
            continue; }
         $len = ($match[1][$i]=='Q:') ? 9 : strlen($match[1][$i]);
         if ($len==9) $q = 1;
         if ($l1==0) { $l1 = $len; $prelen = $l1; }
         if ($len!=$l1 && $l2==0) { $l2 = $len; }
         if ($len!=$l1 && $len!=$l2 && $q==1 && $l3==0) { $l3 = $len; }
         if ($len==$l2 && $l1==9) { $len = $l1; }
         if ($len==$l3) { $len = $l2; }
         if ($len!=$prelen) {
            if ($len==$l1) { $r .= "</$s>"; }
            else if ($len==$l2) { $r .= "<$s class='withalpha'>"; }
         }
         if ($len==$l1 || $len==$l2) {
            $prelen = $len;
            $m = preg_replace("/^(\\[\\[)##/","$1#",$match[2][$i]);
            $m = preg_replace("/^#+/",'',$m);
            if (strpos($m,'[#')==1) $r .= "<$l>".str_replace(']]','#]]',$m)."</$l>\n";
            else {
                $counter++;
           $r .= "<$l>[[#toc$counter ".CrossReference("[[#]]$m","")."]]</$l>\n";
            }
         }
    }
    if ($prelen==$l2) $r .= "</$s>";
    if ($r!='') $r = str_replace('$List',$r,$toc);
    return $r;
}

?>